#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun May 23 09:16:23 2021

@author: eriboulet
"""

# Détermination de la capacité thermique de l'eau

import numpy as np
from math import *
import matplotlib.pyplot as plt

# Masse d'eau (en g)

m = 600

# Tension d'alimentation (en V)

U = 0.00    # A COMPLETER

# Intensité du courant d'alimentation (en A)

I = 0.00    # A COMPLETER

# Saisie des temps t (en minutes)

t = np.array([ , , ])     # A COMPLETER

# Température initiale

theta0=00.0  # A COMPLETER

# Saisie des températures theta(en degrés °C)

theta = np.array([ , , ])    # A COMPLETER

# Calcul des delta theta

deltatheta = theta-theta0

# Tracé de la courbe theta(t)

plt.plot(t,deltatheta, 'bo')
plt.xlabel("t (en s)")
plt.ylabel("deltatheta (en °C)")
plt.show()

# Calcul des pentes de la droite t(theta) en s/°C

p = []
for i in range(len(t)):
    res=t[i]/deltatheta[i]
    p.append(res)

# On néglige la capacité thermique du calorimètre

# Calcul de la capacité thermique de l'eau (moyenne des valeurs)
C1 = U*I*60*np.mean(p)/m
print ('Capacité thermique de l eau :'' C1 = ',C1,'kJ/K/kg')

# Calcul de l'incertitude sur la capacité thermique de l eau (écart type des valeurs/racine(nombre de valeurs))
uC1 = U*I*60*np.std(p)/(len(t)**(1/2))/m
print('Incertitude sur la capacité thermique de l eau : u(C1) =',uC1,'kJ/K/kg')

# Ecart normalisé EN sur C1

C0=4.185    # valeur tabulée en kJ/K/kg en prenant u(C0)=0

EN=abs(C1-C0)/abs(uC1)

print('écart normalisé sur C1 : EN =',EN)



# Conclusion

test=(EN<2) # True = mesures compatibles, False = mesures incompatibles

if test==True :

    print('Mesures compatibles')

else :

    print('Mesures incompatibles')

# On prend en compte la capacité thermique du calorimètre (60 J/K)

# Calcul de la capacité thermique de l'eau (moyenne des valeurs)
C2 = U*I*60*np.mean(p)/(m+14.4)
print ('Capacité thermique de l eau :'' C2 = ',C2,'kJ/K/kg')

# Calcul de l'incertitude sur la capacité thermique de l eau (écart type des valeurs/racine(nombre de valeurs))
uC2 = U*I*60*np.std(p)/(len(t)**(1/2))/m
print('Incertitude sur la capacité thermique de l eau : u(C2) =',uC2,'kJ/K/kg')



# Ecart normalisé EN sur C2

C0=4.185    # valeur tabulée en kJ/K/kg en prenant u(C0)=0

EN=abs(C2-C0)/abs(uC2)

print('écart normalisé sur C2 : EN =',EN)



# Conclusion

test=(EN<2) # True = mesures compatibles, False = mesures incompatibles

if test==True :

    print('Mesures compatibles')

else :

    print('Mesures incompatibles')